<?php

namespace Egoi\Marketing\Observer;

use Magento\Framework\Event\ObserverInterface;

/**
 * Class NewLogin
 *
 * @package Egoi\Marketing\Observer
 */
class CustomerSaveAfter implements ObserverInterface
{

    /**
     * @var \Egoi\Marketing\Model\SubscriberFactory
     */
    protected $egoiHelper;

    /**
     * @var \Egoi\Marketing\Model\SubscriberFactory
     */
    protected $subscriberFactory;

    /**
     * @param  \Egoi\Marketing\Model\SubscriberFactory  $subscriberFactory
     * @param  \Egoi\Marketing\Helper\Data  $egoiHelper
     */
    function __construct(
        \Egoi\Marketing\Model\SubscriberFactory $subscriberFactory,
        \Egoi\Marketing\Helper\Data $egoiHelper
    ) {

        $this->subscriberFactory = $subscriberFactory;
        $this->egoiHelper = $egoiHelper;
    }

    /**
     * @param  \Magento\Framework\Event\Observer  $observer
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {

        try {
            /** @var \Magento\Customer\Model\Customer $customer */
            $customer = $observer->getEvent()->getCustomer();

            $subscriber = $this->subscriberFactory->create()->loadByEmail($customer->getEmail());

            if ($subscriber->getId()) {
                $subscriber->needsSync(true);
            }
        } catch (\Exception $e) {
        }
    }

}
